=== debian/changelog ===
ldc (1:0.17.1-1ubuntu1) xenial; urgency=medium

  * use-std-versions-cmath-ctype-functions.patch: Fix FTBFS
    with GCC 5.3. (LP: #1570006)

 -- Matthias Klumpp <mak@debian.org>  Mon, 18 Apr 2016 23:56:02 +0200

ldc (1:0.17.1-1) unstable; urgency=medium

  * New upstream release

 -- Konstantinos Margaritis <markos@debian.org>  Thu, 24 Mar 2016 23:34:25 +0200
